%global repo_owner  majek
%global repo_name   fluxcapacitor
%global repo_commit f6c7f0775597c1141e718ce32bf79268ac8c33ef
%global repo_date   20180118

%global snap_commit %(c=%{repo_commit}; echo ${c:0:7})
%global snapdata   %{repo_date}git%{snap_commit}

Name:    fluxcapacitor
Version: 0
Release: 6.%{snapdata}%{?dist}
License: MIT

Summary: Run programs without blocking on syscalls
URL:     https://github.com/%{repo_owner}/%{repo_name}
Source0: %{URL}/archive/%{repo_commit}/%{repo_name}-%{repo_commit}.tar.gz

# Program defaults to loading its .so library from the same directory
# where the executable resides. This patch changes it so the shared object
# is loaded from %%{_libdir}/fluxcapacitor instead.
Patch0:  %{name}-load-libs-from-usr-lib-flux.patch

# fluxcapacitor works with syscalls, and these are different between arches.
# Currently only those listed here are supported.
ExclusiveArch: %{ix86} x86_64 %{arm}

# Required to compile
BuildRequires: gcc make
# Required for tests
BuildRequires: perl-interpreter python2


%description
Fluxcapacitor is a tool for making your program run without blocking
on timeouts and on functions like poll() and select(), by spoofing
POSIX time functions. Fluxcapacitor will make your program run faster
and be 100%% CPU constrained. It does that by "speeding up" blocking syscalls.
Faking time is a necessary side effect.

%prep
%setup -q -n %{repo_name}-%{repo_commit}
%patch0 -p1

sed -e 's|__RPM_LIB_DIR__|"%{_libdir}"|' -i src/misc.c


%build
%set_build_flags
make build %{?_smp_mflags}


%check
make test


%install
install -m 755 -d %{buildroot}%{_bindir}
install -m 755 %{name} %{buildroot}%{_bindir}/

install -m 755 -d %{buildroot}%{_libdir}/%{name}
install -m 755 *.so %{buildroot}%{_libdir}/%{name}/

install -m 755 -d %{buildroot}%{_mandir}/man1
install -m 644 %{name}.man %{buildroot}%{_mandir}/man1/%{name}.1


%files
%doc README.md
%license LICENSE-MIT-fluxcapacitor
%{_bindir}/%{name}
%{_libdir}/%{name}
%{_mandir}/man1/*


%changelog
* Wed Jul 18 2018 Artur Iwicki <fedora@svgames.pl> - 0-6.20180118gitf6c7f0
- Update to newest upstream snapshot (dated 2018-01-18)
- Remove Patch1 ("disable wraparound test on 32-bit architectures") - patch accepted upstream
- Add %%set_build_flags to %%build

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0-5.20180114git0b6a11b
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Mon Jan 15 2018 Artur Iwicki <fedora@svgames.pl> 0-4.20180114git0b6a11b
- Move the .so files from %%{_datadir} to %%{_libdir}
- Make Patch1 contain an arch-test, instead of doing if-arch-then-patch

* Sun Jan 14 2018 Artur Iwicki <fedora@svgames.pl> 0-3.20180114git0b6a11b
- Update to newest upstream snapshot
- Remove Source1: man page accepted upstream
- Remove Patch1: "Use 64-bit time values on 32-bit arches" patch accepted upstream

* Sat Jan 13 2018 Artur Iwicki <fedora@svgames.pl> 0-2.20170515gite21a0ef
- Fix typo in summary ("wihout")
- Add info about program limitations to the man page

* Sat Jan 13 2018 Artur Iwicki <fedora@svgames.pl> 0-1.20170515gite21a0ef
- Initial packaging
